#include <time.h>
#include <wand/magick_wand.h>
#include <rfb/rfbclient.h>
#include "screentoimage.h"

void screentoimage_init(void) {
	MagickWandGenesis();
}

void screentoimage_finalize(void) {
	MagickWandTerminus();
}

int screentoimage_write(rfbClient *client, const char *filename) {
	rfbPixelFormat* pf=&client->format;
	int bpp=pf->bitsPerPixel/8;
	int i;

	char *pixels = malloc(client->width*client->height*3);
	for (i = 0; i < client->width*client->height; i++) {
		unsigned char* p=client->frameBuffer+i*bpp;
		unsigned int v;
		if(bpp==4)
			v=*(unsigned int*)p;
		else if(bpp==2)
			v=*(unsigned short*)p;
		else
			v=*(unsigned char*)p;
    char red = (v>>pf->redShift)*256/(pf->redMax+1);
    char green = (v>>pf->greenShift)*256/(pf->greenMax+1);
    char blue = (v>>pf->blueShift)*256/(pf->blueMax+1);
		pixels[3*i] = red;
		pixels[3*i+1] = green;
		pixels[3*i+2] = blue;
	}
	ExceptionInfo exception;
	GetExceptionInfo(&exception);
	ImageInfo image_info;
	GetImageInfo(&image_info);
	image_info.file = fopen(filename, "w");
	strcpy(image_info.magick, "PNG");
	strncpy(image_info.filename, filename, MaxTextExtent);
	Image *image = ConstituteImage ( client->width, client->height, "RGB", CharPixel, pixels, &exception );
	MagickBooleanType ok = WriteImage(&image_info, image);
	return (ok ? 0 : -1);
}
