require 'cocaine'
require 'open3'
require 'tempfile'
require 'shellwords'

class VncClient

	attr_reader :host, :port
	def screenshot options = {}
		@host   = (options[:host])
		@port   = (options[:port])
		@passwd = (options[:passwd])
		@filename = (options[:filename])
		raise "No filename provided" unless @filename
		cmd = Cocaine::CommandLine.new("/usr/local/bin/vncscreenshot",
																	 "#{@host}:#{@port}",
                                   :environment => {
																			'VNCPASSWD' => @passwd,
																			'VNCSCREENSHOT_FILENAME' => @filename
																	 })
    output = cmd.run
	end
	def run options = {}
		@host   = (options[:host])
		@port   = (options[:port])
		@passwd = (options[:passwd])

		raise "need a host to contact" unless @host
		raise "need a port to contact" unless @port

		@passwdfile = Tempfile.new("vnc")
		`echo #{@passwd.shellescape} | vncpasswd -f > #{@passwdfile.path}`
		pin, pout, @thread = Open3.popen2e("vncviewer -passwd #{@passwdfile.path} #{@host.shellescape}:#{@port.shellescape} -fullscreen -shared") 
	end

	def started?
		join unless (@thread.nil? or @thread.alive?)
		@thread.nil? == false
	end

	def stop
		if @thread then	
			begin
				Process.kill("TERM", @thread.pid)
			rescue Errno::ESRCH
			end
		end
		join	
	end

	def join
		@passwdfile.unlink if @passwdfile
		@thread.join if @thread
		@thread = nil
	end
end
