require 'open3'
require 'shellwords'

class VncShare
	attr_reader :port, :passwd

	CMD = "x11vnc"

	def initialize options = {}
		@passwd = options[:passwd]
		@display = options[:display]
		@clip = options[:clip]
	end

	def run

		cmd = CMD
		cmd += " -display #{@display}" if @display
		cmd += " -noshm" if @display and @display != ":0"
		cmd += " -passwd #{@passwd}" if @display
		cmd += " -clip #{@clip}" if @clip
		cmd += " -forever"
		cmd += " -shared"

		@vnc_pin, @vnc_pout, @thread =  Open3.popen2e(cmd)

		raise "Can't share desktop" unless @thread

		@port = nil
		@log_lines = ""
		@vnc_pout.each_line do |line|
			@log_lines += line
			m = /PORT=(\d+)/.match(line)
			if m then
				@port = m[1]
				break
			end
		end
		if @port then
			puts "Vnc running on port #{@port}"
		else
			puts "Something went wrong :"
			puts @log_lines
			stop
		end
	end
	def started?
		@thread != nil
	end
	def stop
		return unless @thread
		@thread.kill
		join
	end

	def join
		@thread.join if @thread
	end
end
